Summary:        Extension for creating pdf-Files with CUPS
Summary(fr):    Extension de CUPS pour créer des fichiers PDF
Name:           cups-pdf
Version:        3.0.1
Release:    1%{?dist}
URL:            https://www.cups-pdf.de/
License:        GPL-2.0-or-later

Source0:        https://www.cups-pdf.de/src/%{name}_%{version}.tar.gz
Source1:        INSTALL.ocs.cups-pdf

Patch1:         cups-pdf-conf.patch
Patch2:         cups-pdf-desktop.patch
Patch3:         cups-pdf-title.patch
Patch4:         cups-pdf-build.patch
Patch5:         cups-pdf-result.patch
Patch6:         cups-pdf-setpdfwrite.patch
Patch7:         cups-pdf-fix-null-chars.patch

BuildRequires:  gcc
BuildRequires:  cups-devel

Requires:       ghostscript, cups
Requires(post): %{_bindir}/pgrep


%global CPSPOOL   %{_localstatedir}/spool/cups-pdf/SPOOL

%global CPOUT     %{_localstatedir}/spool/cups-pdf

%global CPLOG     %{_localstatedir}/log/cups

%global ETCCUPS   %(cups-config --serverroot 2>/dev/null || echo %{_sysconfdir}/cups)

%global CPBACKEND %(cups-config --serverbin  2>/dev/null || echo %{_libdir}/cups)/backend


%description
"cups-pdf" is a backend script for use with CUPS - the "Common UNIX Printing
System" (see more for CUPS under https://www.cups.org/). 
"cups-pdf" uses the ghostscript pdfwrite device to produce PDF Files.

This version has been modified to store the PDF files on the Desktop of the 
user. This behavior can be changed by editing the configuration file.

%description -l fr
"cups-pdf" est un script de traitement CUPS - le "Common UNIX Printing System"
(plus d'informations sur CUPS à l'adresse https://www.cups.org/). 
"cups-pdf" utilise ghostscript pour construire des fichiers au format PDF.

Cette version a été modifiée pour produire les fichiers PDF sur le bureau
de l'utilisateur (dossier Desktop du répertoire d'accueil de l'utilisateur).
Ce comportement peut être modifié en éditant le fichier de configuration.


%prep
echo CIBLE = %{name}-%{version}-%{release}
%setup -q -n %{name}-%{version}
cp -p %{SOURCE1} INSTALL.RPM

%patch1 -p0 -b .oldconf
%patch2 -p0 -b .desktop
%patch3 -p0 -b .title
%patch4 -p0 -b .build
%patch5 -p0 -b .result
%patch6 -p0 -b .setpdfwrite
%patch7 -p1 -b .nullchars


%build
pushd src
%{__cc} $RPM_OPT_FLAGS $RPM_LD_FLAGS -D_GNU_SOURCE -o cups-pdf cups-pdf.c -lcups
popd


%install
mkdir -p %{buildroot}%{CPBACKEND}
mkdir -p %{buildroot}%{CPSPOOL}
mkdir -p %{buildroot}%{CPOUT}
mkdir -p %{buildroot}%{CPLOG}
mkdir -p %{buildroot}%{CPBACKEND}
mkdir -p %{buildroot}%{ETCCUPS}
mkdir -p %{buildroot}%{_datadir}/cups/model/
install -p -m644 extra/{CUPS-PDF_noopt,CUPS-PDF_opt}.ppd  %{buildroot}%{_datadir}/cups/model/
install -p -m644 extra/cups-pdf.conf %{buildroot}%{ETCCUPS}/
install -p -m700 src/cups-pdf %{buildroot}%{CPBACKEND}/



%post
if [ "$1" -eq "1" ] && %{_bindir}/pgrep -u root -f %{_sbindir}/cupsd >/dev/null
then
    /usr/sbin/lpadmin -p Cups-PDF -v cups-pdf:/ -m CUPS-PDF_noopt.ppd -E || :
fi


%postun
if [ "$1" -eq "0" ]; then
    /usr/sbin/lpadmin -x Cups-PDF || :
fi


%files
%license COPYING
%doc ChangeLog README INSTALL.RPM
%dir %{CPSPOOL}
%dir %{CPOUT}
%attr(700, root, root) %{CPBACKEND}/cups-pdf
%config(noreplace) %{ETCCUPS}/cups-pdf.conf
%{_datadir}/cups/model/CUPS-PDF_noopt.ppd
%{_datadir}/cups/model/CUPS-PDF_opt.ppd


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.1-1
- initial build
